<?php // $Id: admin.php,v 1.9 2003/05/26 00:36:58 bravecobra Exp $
// ----------------------------------------------------------------------
// Module: ContentExpress
// Copyright (C) 2002 by the Content Express Development Team.
//                           Arising Group, Inc.
// http://xexpress.sourceforge.net/
// Original Author of file: Chester Chee
// Purpose of file:  Language defines for pnadmin.php
// ----------------------------------------------------------------------
//
// Menu item related messages
define('_MENUCONTENTMENUCREATED',       'Menu item created');
define('_MENUCONTENTMENUDELETED',       'Menu item deleted');
define('_MENUCONTENTMENUUPDATED',       'Menu item updated');
define('_CANCELMENUCONTENTMENUDELETE',  'Cancel deletion of menu item');
define('_CONFIRMMENUCONTENTMENUDELETE', 'Confirm deletion of menu item');
define('_MENUCONTENTMISSINGNAME',       'Menu item\'s name is missing');
define('_MENUCONTENTMISSINGURI',        'Menu item\'s URI is missing.');

// Menu item related labels
define('_MENUCONTENTMENUNAME',          'Menu Name');
define('_MENUCONTENTMENUTYPE',          'Menu Type');
define('_MENUCONTENTMENUTYPE1',         'Spacer');
define('_MENUCONTENTMENUTYPE2',         'Title');
define('_MENUCONTENTMENUTYPE3',         'Module');
define('_MENUCONTENTMENUTYPE4',         'Custom URL');
define('_MENUCONTENTMENUTYPE5',         'Clickable Title');
define('_MENUCONTENTMENUTYPE6',         'Index Page');
define('_MENUCONTENTMENUURI',           'Menu URI');
define('_MENUCONTENTMENUPARENT',        'Parent Menu');
define('_MENUCONTENTBLOCK',             'CE Menu Block');
define('_MENUCONTENTALLBLOCKS',         'All CE Menu Blocks');
define('_MENUCONTENTMENULANG',          'Language');
define('_MENUCONTENTMENUWEIGHT',        'Weight');
define('_MENUCONTENTMENUACTIVE',        'Active');
define('_MENUCONTENTMENUNEWWINDOW',     'Use New Window');
define('_MENUCONTENTMENUOPTIONS',       'Actions');
define('_MENUCONTENTMENUEDIT',          'Edit Menu');
define('_MENUCONTENTMENUDELETE',        'Delete Menu');
define('_MENUCONTENTMENUSTATE',         'Approval Status');
define('_MENUCONTENTMENUIMAGES',        'Menu Item Images');
define('_MENUCONTENTMENUROLLIMGA',      'Rollover Image A');
define('_MENUCONTENTMENUROLLIMGB',      'Rollover Image B');
define('_MENUCONTENTMENUBGIMG',         'Background Image');

// Menu item related actions
define('_MENUCONTENTUPDATEMENU',        'Update Menu');
define('_MENUCONTENTSAVEMENU',          'Save Menu');
define('_MENUCONTENTVIEWMENUS',         'Manage Menus');
define('_MENUCONTENTADDMENU',           'Add Menu');

// Content related messages
define('_MENUCONTENTCONTENTCREATED',       'Page content created');
define('_MENUCONTENTCONTENTDELETED',       'Page content deleted');
define('_MENUCONTENTCONTENTUPDATED',       'Page content updated');
define('_CANCELMENUCONTENTCONTENTDELETE',  'Cancel deletion of page content');
define('_CONFIRMMENUCONTENTCONTENTDELETE', 'Confirm deletion of page content');
define('_MENUCONTENTBADIMGTYPE',           'Unsupported media file type');
define('_MENUCONTENTIMGTOOBIG',            'Media file size too large');
define('_MENUCONTENTIMGINUSE',             'Unable to remove media file that is currently in use');
define('_MENUCONTENTIMGCOPYFAILED',        'Unable to copy media file to media repository');
define('_MENUCONTENTMEDIAUPLOADFAILED',    'Unable to upload media file to media repository');
define('_MENUCONTENTMISSINGTITLE',         'Title is missing');
define('_MENUCONTENTBADDATE',              'Bad Date');

// Content item related labels
define('_MENUCONTENTCONTENTNAME',          'Title');
define('_MENUCONTENTCONTENTTITLEALIGN',    'Title Alignment');
define('_MENUCONTENTCONTENTTEXT',          'Page Editor');
define('_MENUCONTENTCONTENTPARENT',        'Parent');
define('_MENUCONTENTCONTENTLAYOUT',        'Media Layout');
define('_MENUCONTENTCONTENTNOLAYOUT',      'Hide Media');
define('_MENUCONTENTCONTENTCATEGORY',      'Category');
define('_MENUCONTENTCONTENTIMAGEUPLD',     'Media Upload');
define('_MENUCONTENTCONTENTIMAGEDIM',      'Media Dimension (WxH in pixel)');
define('_MENUCONTENTCONTENTIMAGEDIMHELP',  'Note: 0 x 0 defaults to image dimension');
define('_MENUCONTENTCONTENTLANG',          'Language');
define('_MENUCONTENTCONTENTACTIVE',        'Active');
define('_MENUCONTENTTITLEACTIVE',          'Enable Title');
define('_MENUCONTENTCONTENTOPTIONS',       'Actions');
define('_MENUCONTENTCONTENTEDIT',          'Edit Page Content');
define('_MENUCONTENTCONTENTDELETE',        'Delete Page Content');
define('_MENUCONTENTTOPPRINT',             'Enable Top Print Anchor');
define('_MENUCONTENTBOTTOMPRINT',          'Enable Bottom Print Anchor');
define('_MENUCONTENTCONTENTSTATE',         'Approval Status');
define('_MENUCONTENTSTARTDATE',            'Publication Date');
define('_MENUCONTENTENDDATE',              'Expiration Date');
define('_MENUCONTENTSCHEDULE',             'Schedule Page Content');
define('_MENUCONTENTSCHEDULEMENU',         'Schedule Menu');
define('_MENUCONTENTNAVIGATION',           'Enable Article Navigation');
define('_MENUCONTENTINDEXDEPTH',           'Index page depth (Set to -1 for unlimited)');
define('_MENUCONTENTTOPSENDFRIEND',        'Send to a friend Top Anchor');
define('_MENUCONTENTBOTTOMSENDFRIEND',     'SendTo a friend Bottom Anchor');
define('_MENUCONTENTBACKGROUDCOLOR',       'Background color');
define('_MENUCONTENTLASTUPDATED',          'Last Updated');
define('_MENUCONTENTTIMESREAD',            'Times Read');
define('_MENUCONTENTSHOWLASTUPDATED',      'Show Last Updated');
define('_MENUCONTENTSHOWTIMESREAD',        'Show Times Read');
define('_MENUCONTENTTIMEFORMAT',           'Time format (Check date function in PHP for reference)');
define('_MENUCONTENTSHOWTIMESREADINDEX',   'Show \'times read\' in index page');
define('_MENUCONTENTSHOWAUTHORINDEX',      'Show \'author label\' in index page');
define('_MENUCONTENTAUTHOR',               'Author');
define('_MENUCONTENTNOTES',                'Internal notes');


// Content item related actions

define('_MENUCONTENTSELECTBLOCK',       'Select Menu Block');
define('_MENUCONTENTUPDATECONTENT',     'Update Content');
define('_MENUCONTENTSAVECONTENT',       'Save Content');
define('_MENUCONTENTVIEWCONTENTS',      'Manage Page Contents');
define('_MENUCONTENTADDCONTENT',        'Add Page Content');
define('_MENUCONTENTNOCATEGORY',        'No Category');

// Category item related labels
define('_MENUCONTENTCATCREATED',       'Category created');
define('_MENUCONTENTCATUPDATED',       'Category updated');
define('_MENUCONTENTCATDELETED',       'Category deleted');
define('_MENUCONTENTUPDATECAT',        'Update Category');
define('_MENUCONTENTNEWCAT',           'New Category');
define('_MENUCONTENTVIEWCATS',         'Manage Categories');
define('_MENUCONTENTADDCAT',           'Add Category');
define('_MENUCONTENTSAVECAT',          'Save Category');
define('_MENUCONTENTCATEDIT',          'Edit Category');
define('_MENUCONTENTCATDELETE',        'Delete Category');
define('_CONFIRMMENUCONTENTCATDELETE', 'Confirm deletion of category');
define('_CANCELMENUCONTENTCATDELETE',  'Cancel deletion of category');
define('_MENUCONTENTBADCATEGORYNAME',  'Bad Category Name');

// General messages
if (!defined('_MENUCONTENTNOAUTH')) {
	define('_MENUCONTENTNOAUTH','Not authorised to access ContentExpress module');
}
define('_MENUCONTENTNOSUCHITEM', 'No such item');
define('_CREATEFAILED', 'Creation attempt failed');
define('_UPDATEFAILED', 'Modification attempt failed');
define('_DELETEFAILED', 'Deletion attempt failed');
define('_UPDATETABLEFAILED', 'Table update failed');

// General labels
define('_MENUCONTENT',                  'Content Express');

// General actions
define('_MENUCONTENTDEACTIVATE',        'Deactivate');
define('_MENUCONTENTACTIVATE',          'Activate');
define('_MENUCONTENTDELETE',            'Delete');
define('_MENUCONTENTEDIT',              'Edit');
define('_MENUCONTENTMOVELEFT',          'Left');
define('_MENUCONTENTCENTER',            'Center');
define('_MENUCONTENTMOVERIGHT',         'Right');
define('_MENUCONTENTMOVEUP',            'Up');
define('_MENUCONTENTMOVEDOWN',          'Down');
define('_MENUCONTENTTOPLEVEL',          'Top Level');
if (!defined('_CONFIRM')) {
	define('_CONFIRM', 'Confirm');
}

// Configuration labels
define('_MENUCONTENTEDITCECONFIG',   'Page Configuration');
define('_MENUCONTENTMODIFYCECONFIG', 'Modify content configuration');
define('_MENUCONTENTEDITMECONFIG',   'Menu Configuration');
define('_MENUCONTENTMODIFYMECONFIG', 'Modify menu configuration');
define('_MENUCONTENTEDITMMECONFIG',  'Media Configuration');
define('_MENUCONTENTMODIFYMMECONFIG','Modify media configuration');
define('_MENUCONTENTDEFAULTCONTENT', 'Default Content Page');
define('_MENUCONTENTIMAGETYPES',     'Supported Media Types');
define('_MENUCONTENTMAXIMGSIZE',     'Max. media file size (in Bytes)');
define('_MENUCONTENTIMAGEDIR',       'Media Repository');
define('_MENUCONTENTQADMIN',         'Enable Quick Admin Link');
define('_MENUCONTENTAUTOCLEAN',      'Enable media auto-clean (If enabled, CE keeps track of ref. count (RC) on media; once RC reaches 0, CE deletes the corresponding media from the repository)');
define('_MENUCONTENTWYSIWYG',        'Enable WYSIWYG Editor');
define('_CONTENTWYSIWYGHEIGHT',      'WYSIWYG Editor Height');
define('_CONTENTWYSIWYGWIDTH',       'WYSIWYG Editor Width');
define('_MENUCONTENTPNMENU',         'Enable PN Menublock Style');
define('_MENUCONTENTCONFIGUPDATED',  'Configuration updated');
define('_MENUCONTENTNONE',  'None');

// Configuration action
define('_MENUCONTENTUPDATECONFIG',     'Update Configuration');
define('_LOADFAILED', 'Load of module failed');

// Media manager labels
define('_MENUCONTENTMEDIAMGR',         'Manage Media');
define('_MENUCONTENTMEDIADELETE',      'Media to be removed');
define('_MENUCONTENTMEDIADUPLICATE',   'Duplicate media not allow, choose a different filename prior to upload');

// Media manage action
define('_MENUCONTENTUPDATEREPOSITORY', 'Update Media Repository');
define('_MENUCONTENTMEDIAUPDATED',     'Media Repository Updated');
?>